﻿var WordEnv = (function() {
    var global = {
        rootElem: 'article',
        prefix: function (selector) {
            return WordEnv.rootElem + ' ' + selector;
        },
        gaijiDir: function () {
            return expertjs.getGaijiDirectory();
        },
        kanjiDir: function () {
            return expertjs.getKanjiDirectory();
        },
        kanjiFullDir: function () {
            return expertjs.getKanjiFullDirectory();
        },
        figureDir: function () {
            return expertjs.getNetworkFigureDirectory();
        },
        mtiSearchUrl: function () {
            return expertjs.getMtiWordSearchUrl();
        },
        dicTitle: function(dictionaryCode) {
            return expertjs.getDictionaryTitle(dictionaryCode);
        },
        dicVersion: function(dictionaryCode) {
            return expertjs.getDictionaryVersion(dictionaryCode);
        },
        isScreenWideEnough: function() {
            return fragmentjs.isScreenWideEnough();
        },
        preprocess: function() {
            function convertSIL(node) {
                node.contents().each(function() {
                    if (this.nodeType == 1) {
                        if (this.nodeName.toLowerCase() == 'span' && $(this).hasClass('sil')) {
                            // pass
                        }
                        else {
                            convertSIL($(this));
                        }
                    }
                    else if (this.nodeType == 3) {
                        $(this).replaceWith(expertjs.makeSpanSIL(this.nodeValue));
                    }
                });
            }
            var root = document.querySelector(WordEnv.rootElem);
            var dictionaryCode = root.getAttribute('dicCode');
            var errorCode = root.getAttribute('errorCode');
            var version = WordEnv.dicVersion(dictionaryCode) + '';

            // anchor link
            $(WordEnv.prefix('a')).each(function() {
                if (errorCode && errorCode.indexOf('state') == 0) {
                    // Handle in Java
                }
                else {
                    var temp = $(this).attr('href');
                    if (typeof temp !== 'undefined') {
                        if ($(this).hasClass('external')) {
                            // pass
                        }
                        else {
                            var params = temp.split('-');
                            if (params.length == 1) {
                                var dicCode = dictionaryCode;
                                var wordCode = params[0];
                            }
                            else if (params.length == 2) {
                                var dicCode = params[0];
                                var wordCode = params[1];
                            }
                            var href = WordEnv.mtiSearchUrl() + dicCode + '/' + version + '/' + wordCode;
                            $(this).attr('href', href);
                        }
                    }
                }
            }).on('click', function(e) {
                e.stopPropagation();
            });
            if (dictionaryCode == "ej_dic" && !errorCode) {
                var h1 = $(WordEnv.prefix("header.main > h1"));
                h1.html(expertjs.normalizeEJTitle(h1.html()));
                convertSIL($(WordEnv.prefix("section.origin > p")));
            }
        },
        postprocess: function () {
            var root = document.querySelector(WordEnv.rootElem);
            var errorCode = root.getAttribute('errorCode');

            // Reload if state require auth
            if (errorCode == 'state_require_auth') {
                fragmentjs.checkNetworkAccountStatus();
            }
        },
        reload: function (successCallback) {
            fragmentjs.reload();
        },
        popupImage: function (popupPath, element) {
            fragmentjs.popupImage(popupPath);
        },
        popupVerticalScrollImage: function (popupPath, element) {
            fragmentjs.popupVerticalScrollImage(popupPath);
        }
    };
    return global;
})();
